import sys, pygame, string, random, strategy
import sys, pygame, string, random, strategy
from constants import *

# class for armies
class Army:
  def __init__(self, location, color):
    global nextID
    self.location= location
    self.color= color
    self.id= nextID
    nextID+=1
nextID=1

#A class for countries
class Country:
  def __init__(self, level, color):
    self.owner= color
    self.occupier= color
    self.level=level
    self.siege=-1
    self.income= INCOME

#A class for decisions
class Decision:
  message=""
  prompt=""
  Dtype=""
  color1=""
  color2=""
  def __init__(self, message, prompt, Dtype, color1, color2):
    self.message=message
    self.prompt= prompt
    self.Dtype= Dtype
    self.color1= color1
    self.color2= color2
    
#A class for info messages
class Message:
  message=""
  type=""
  def __init__(self, message, type):
    self.type= type
    self.message= message
    self.message= message

#A class for players
class Player:
  #Initializes a player
  def __init__(self, house, color):
    self.color= color
    self.house= house
    self.AI= strategy.Hadrian(color)
    self.titles=[]
    self.title="King"
    self.heirs=[]
    self.daughters=1
    self.__line= {}
    self.reRoll()
  #Converts an integer to a roman numeral
  def __intToRoman(self, n):
    if n<=0: return ""
    elif n >= 1000: return "M"+self.__intToRoman(n-1000)
    elif n >= 995: return "VM"+self.__intToRoman(n-995)
    elif n >= 990: return "XM"+self.__intToRoman(n-990)
    elif n >= 950: return "LM"+self.__intToRoman(n-950)
    elif n >= 900: return "CM"+self.__intToRoman(n-900)
    elif n >= 500: return "D"+self.__intToRoman(n-500)
    elif n >= 495: return "VD"+self.__intToRoman(n-495)
    elif n >= 490: return "XD"+self.__intToRoman(n-490)
    elif n >= 450: return "LD"+self.__intToRoman(n-450)
    elif n >= 400: return "CD"+self.__intToRoman(n-400)
    elif n >= 100: return "C"+self.__intToRoman(n-100)
    elif n >= 95: return "VC"+self.__intToRoman(n-95)
    elif n >= 90: return "XC"+self.__intToRoman(n-90)
    elif n >= 50: return "L"+self.__intToRoman(n-50)
    elif n >= 45: return "VL"+self.__intToRoman(n-45)
    elif n >= 40: return "XL"+self.__intToRoman(n-40)
    elif n >= 10: return "X"+self.__intToRoman(n-10)
    elif n >= 9: return "IX"+self.__intToRoman(n-9)
    elif n >= 5: return "V"+self.__intToRoman(n-5)
    elif n >= 4: return "IV"+self.__intToRoman(n-4)
    else: return "I"+self.__intToRoman(n-1)
  #Returns the name of the lord of this household
  def getLord(self):
    return self.title+" "+self.lord
  #Returns increments the number associated with a name
  def __numeral(self, name):
    if not name in self.__line:
      self.__line[name]= 1
    else:
      self.__line[name]+=1
  #Elevates the house heir, rolling new trait levels
  def reRoll(self):
    global NAMES, MONKIERS
    self.honor=int(random.random()*6 - 3)
    self.greed=int(random.random()*6 - 3)
    self.command=int(random.random()*6 - 3)
    self.subtlety=int(random.random()*6 - 3)
    self.dread=int(random.random()*6 - 3)
    if len(self.heirs)==0:
      self.heirs= random.sample(NAMES, 4)
    self.monkier= random.sample(MONKIERS,1)[0]
    name= self.heirs.pop(0)
    self.__numeral(name)
    self.lord= name+" "+self.__intToRoman(self.__line[name])+" "+self.house
  #Returns a string representation of a house
  def toString(self):
    global players
    result= "House "+self.house+"\n"
    result+=" (under "+self.getLord()+", the "+self.monkier+")\n"
    result+="  Honor: "+str(self.honor)+"\n"
    result+="  Greed: "+str(self.greed)+"\n"
    result+="  Command: "+str(self.command)+"\n"
    result+="  Subtlety: "+str(self.subtlety)+"\n"
    result+="  Dread: "+str(self.dread)+"\n"
    result+="\n  Marriageable Daughters: "+str(self.daughters)+"\n"
    vassals=[]
    if self.color in bannersDict: vassals.extend(bannersDict[self.color])
    else: vassals.append(self.color)
    vassals.remove(self.color)
    if len(vassals)>0:
      result+="  Sworn Houses: \n"
      for color in vassals:
        result+="    House "+players[color].house+"\n"
      result+="  Liege Granted Titles: "
      for land in self.titles:
        result+=string.capwords(land)+", "
    return result
  #Appends a new heir onto the succession queue
  def heir(self):
    global NAMES
    self.heirs.extend(random.sample(NAMES, 1))
  #Returns the maximum attribute of this House
  def maxAttribute(self):
    select= max([self.honor,self.greed,self.dread,self.subtlety,self.command])
    if self.honor==select: return "honor"
    elif self.greed==select: return "greed"
    elif self.subtlety==select: return "subtlety"
    elif self.command==select: return "command"
    elif self.dread==select: return "dread"
  #Returns the minimum attribute of this House
  def minAttribute(self):
    select= min([self.honor,self.greed,self.dread,self.subtlety,self.command])
    if self.honor==select: return "honor"
    elif self.greed==select: return "greed"
    elif self.subtlety==select: return "subtlety"
    elif self.command==select: return "command"
    elif self.dread==select: return "dread"    

#Parses map territory locations
def parseMapLocations(MAP):
  #Reads in the center locations
  f= open(MAP+"/locations.dat")
  countryLocs= {}
  line= f.readline()
  while line != "":
    index= line.replace("\n", "").find(":")
    if index >= 0:
      name= line[0:index]
      line= line[index+1:len(line)]
      index= line.find(",")
      if index >=0:
        countryLocs[name]= (int(line[0:index]), int(line[index+1:len(line)]))
    line= f.readline()
  f.close()
  #Reads in the territory ajdacencies
  f= open(MAP+"/adjacency.dat")
  adjFile= f.readlines()
  adj=[]
  for line in adjFile:
    adj.append(line.replace("\n",""))
  f.close()
  return countryLocs, adj

#Parse map stats
def parseMapStats(MAP):
  f= open(MAP+"/config.dat")
  countryStats= {}
  line= f.readline()
  while line != "":
    index= line.replace("\n", "").find(":")
    if index >= 0:
      name= line[0:index]
      line= line[index+1:len(line)]
      index= line.find(",")
      if index >=0:
        color= line[index+1:len(line)].strip()
        countryStats[name]= Country(int(line[0:index]), color)
    line= f.readline()
  f.close()
  return countryStats

#Initializes pygame module
pygame.init()

#Load fullscreen images
mapIm= pygame.image.load(MAP+"/map.png")
presentsIm= pygame.image.load("images/loading/presents.png")
splashIm= pygame.image.load("images/loading/splash.png")
menuIm= pygame.image.load("images/loading/homeMenu.png")
infoScreen= pygame.image.load("images/loading/info.png")

#Load images
towerIm= pygame.image.load("images/tower.png")
keepIm= pygame.image.load("images/keep.png")
cityIm= pygame.image.load("images/city.png")
consIm= pygame.image.load("images/construction.png")
button= pygame.image.load("images/button.png")

redMarker= pygame.image.load("images/markers/redMarker.png")
orangeMarker= pygame.image.load("images/markers/orangeMarker.png")
yellowMarker= pygame.image.load("images/markers/yellowMarker.png")
greenMarker= pygame.image.load("images/markers/greenMarker.png")
blueMarker= pygame.image.load("images/markers/blueMarker.png")
purpleMarker= pygame.image.load("images/markers/purpleMarker.png")
whiteMarker= pygame.image.load("images/markers/whiteMarker.png")
blackMarker= pygame.image.load("images/markers/blackMarker.png")

redHalfMarker= pygame.image.load("images/markers/redHalfMarker.png")
orangeHalfMarker= pygame.image.load("images/markers/orangeHalfMarker.png")
yellowHalfMarker= pygame.image.load("images/markers/yellowHalfMarker.png")
greenHalfMarker= pygame.image.load("images/markers/greenHalfMarker.png")
blueHalfMarker= pygame.image.load("images/markers/blueHalfMarker.png")
purpleHalfMarker= pygame.image.load("images/markers/purpleHalfMarker.png")
whiteHalfMarker= pygame.image.load("images/markers/whiteHalfMarker.png")
blackHalfMarker= pygame.image.load("images/markers/blackHalfMarker.png")

redArmy= pygame.image.load("images/redArmy.png")
orangeArmy= pygame.image.load("images/orangeArmy.png")
yellowArmy= pygame.image.load("images/yellowArmy.png")
greenArmy= pygame.image.load("images/greenArmy.png")
blueArmy= pygame.image.load("images/blueArmy.png")
purpleArmy= pygame.image.load("images/purpleArmy.png")
whiteArmy= pygame.image.load("images/whiteArmy.png")
blackArmy= pygame.image.load("images/blackArmy.png")
armySelection= pygame.image.load("images/armySelection.png")

redBend= pygame.image.load("images/heraldry/redBend.png")
redBar= pygame.image.load("images/heraldry/redBar.png")
redCross= pygame.image.load("images/heraldry/redCross.png")
redQuarter= pygame.image.load("images/heraldry/redQuarter.png")
redCrescent= pygame.image.load("images/heraldry/redCrescent.png")

orangeBend= pygame.image.load("images/heraldry/orangeBend.png")
orangeBar= pygame.image.load("images/heraldry/orangeBar.png")
orangeCross= pygame.image.load("images/heraldry/orangeCross.png")
orangeQuarter= pygame.image.load("images/heraldry/orangeQuarter.png")
orangeCrescent= pygame.image.load("images/heraldry/orangeCrescent.png")

yellowBend= pygame.image.load("images/heraldry/yellowBend.png")
yellowBar= pygame.image.load("images/heraldry/yellowBar.png")
yellowCross= pygame.image.load("images/heraldry/yellowCross.png")
yellowQuarter= pygame.image.load("images/heraldry/yellowQuarter.png")
yellowCrescent= pygame.image.load("images/heraldry/yellowCrescent.png")

greenBend= pygame.image.load("images/heraldry/greenBend.png")
greenBar= pygame.image.load("images/heraldry/greenBar.png")
greenCross= pygame.image.load("images/heraldry/greenCross.png")
greenQuarter= pygame.image.load("images/heraldry/greenQuarter.png")
greenCrescent= pygame.image.load("images/heraldry/greenCrescent.png")

blueBend= pygame.image.load("images/heraldry/blueBend.png")
blueBar= pygame.image.load("images/heraldry/blueBar.png")
blueCross= pygame.image.load("images/heraldry/blueCross.png")
blueQuarter= pygame.image.load("images/heraldry/blueQuarter.png")
blueCrescent= pygame.image.load("images/heraldry/blueCrescent.png")

purpleBend= pygame.image.load("images/heraldry/purpleBend.png")
purpleBar= pygame.image.load("images/heraldry/purpleBar.png")
purpleCross= pygame.image.load("images/heraldry/purpleCross.png")
purpleQuarter= pygame.image.load("images/heraldry/purpleQuarter.png")
purpleCrescent= pygame.image.load("images/heraldry/purpleCrescent.png")

whiteBend= pygame.image.load("images/heraldry/whiteBend.png")
whiteBar= pygame.image.load("images/heraldry/whiteBar.png")
whiteCross= pygame.image.load("images/heraldry/whiteCross.png")
whiteQuarter= pygame.image.load("images/heraldry/whiteQuarter.png")
whiteCrescent= pygame.image.load("images/heraldry/whiteCrescent.png")

blackBend= pygame.image.load("images/heraldry/blackBend.png")
blackBar= pygame.image.load("images/heraldry/blackBar.png")
blackCross= pygame.image.load("images/heraldry/blackCross.png")
blackQuarter= pygame.image.load("images/heraldry/blackQuarter.png")
blackCrescent= pygame.image.load("images/heraldry/blackCrescent.png")

redBlazons= [redBar, redBend, redCross, redQuarter, redCrescent]
orangeBlazons= [orangeBar, orangeBend, orangeCross, orangeQuarter, orangeCrescent]
yellowBlazons= [yellowBar, yellowBend, yellowCross, yellowQuarter, yellowCrescent]
greenBlazons= [greenBar, greenBend, greenCross, greenQuarter, greenCrescent]
blueBlazons= [blueBar, blueBend, blueCross, blueQuarter, blueCrescent]
purpleBlazons= [purpleBar, purpleBend, purpleCross, purpleQuarter, purpleCrescent]
whiteBlazons= [whiteBar, whiteBend, whiteCross, whiteQuarter, whiteCrescent]
blackBlazons= [blackBar, blackBend, blackCross, blackQuarter, blackCrescent]

infoBox= pygame.image.load("images/InfoBox.png")
decisionBox= pygame.image.load("images/decisionBox.png")
menuBox= pygame.image.load("images/Menu.png")

screen = pygame.display.set_mode(size, pygame.FULLSCREEN, 32)

#Resets the game state to the initial configuration
def reset():
  global countryStats, countryLocs, armies, building, coffers, ordersQueue, message
  global bannersDict, infoMessages, decisionQueue, allianceAsked, assassinsQueue
  global bribeQueue, players, adjacency, failedAssassins, heraldry
  
  countryStats= parseMapStats(MAP)
  countryLocs, adjacency= parseMapLocations(MAP)
  armies=[]
  building={}
  coffers={}
  ordersQueue={}
  message=""
  bannersDict= {}
  infoMessages= []
  decisionQueue=[]
  allianceAsked=[]
  assassinsQueue= []
  bribeQueue=[]
  failedAssassins= 0

  #Initialize the player stat tracking
  players= {}
  players["redandyellow"]= Player("Virelle", "redandyellow")
  players["orangeandwhite"]= Player("Cuffy", "orangeandwhite")
  players["yellowandorange"]= Player("Terrowyn", "yellowandorange")
  players["greenandwhite"]= Player("Lasconse", "greenandwhite")
  players["blueandyellow"]= Player("Falconie", "blueandyellow")
  players["purple"]= Player("Martyn", "purple")
  players["whiteandblue"]= Player("de Grey", "whiteandblue")
  players["blackandred"]= Player("Dire", "blackandred")
  players["orangeandred"]= Player("Demont", "orangeandred")
  players["whiteandpurple"]= Player("Whentley", "whiteandpurple")
  
  #initialize heraldries
  heraldry= {}
  heraldry["redandyellow"]=yellowCross
  heraldry["orangeandwhite"]=whiteCrescent
  heraldry["yellowandorange"]=orangeCross
  heraldry["greenandwhite"]=whiteQuarter
  heraldry["blueandyellow"]=yellowCrescent
  heraldry["purple"]=purpleQuarter
  heraldry["whiteandblue"]=blueBend
  heraldry["orangeandred"]=redBar
  heraldry["blackandred"]=redBar
  heraldry["whiteandpurple"]=purpleBend

#Clears all orders from the queue
def clearOrders():
  global ordersQueue
  ordersQueue= {}
  for army in armies:
    ordersQueue[army]= army.location

#draw a country
def drawCountry(countryName, color, cityLevel):
  global countryLocs, screen, towerIm, keepIm, cityIm, consIm, building
  global redMarker, orangeMarker, yellowMarker, greenMarker 
  global blueMarker, purpleMarker, whiteMarker, blackMarker
  x,y= countryLocs[countryName]
  x3, y3= x-10, y-10
  if countryName in building:
    screen.blit(consIm, (x3,y3))
  x2, y2 = x-5, y+55
  if color[0:len("red")]=="red":
    screen.blit(redMarker, (x2, y2))
  elif color[0:len("orange")] == "orange":
    screen.blit(orangeMarker, (x2, y2))
  elif color[0:len("yellow")] == "yellow":
    screen.blit(yellowMarker, (x2, y2))
  elif color[0:len("green")] == "green":
    screen.blit(greenMarker, (x2, y2))
  elif color[0:len("blue")] == "blue":
    screen.blit(blueMarker, (x2, y2))
  elif color[0:len("purple")] == "purple":
    screen.blit(purpleMarker, (x2, y2))
  elif color[0:len("white")] == "white":
    screen.blit(whiteMarker, (x2, y2))
  elif color[0:len("black")]=="black":
    screen.blit(blackMarker, (x2, y2))
    
  if color[len(color)-len("red"):len(color)]=="red":
    screen.blit(redHalfMarker, (x2,y2))
  elif color[len(color)-len("orange"):len(color)]=="orange":
    screen.blit(orangeHalfMarker, (x2,y2))
  elif color[len(color)-len("yellow"):len(color)]=="yellow":
    screen.blit(yellowHalfMarker, (x2,y2))
  elif color[len(color)-len("green"):len(color)]=="green":
    screen.blit(greenHalfMarker, (x2,y2))
  elif color[len(color)-len("blue"):len(color)]=="blue":
    screen.blit(blueHalfMarker, (x2,y2))
  elif color[len(color)-len("purple"):len(color)]=="purple":
    screen.blit(purpleHalfMarker, (x2,y2))
  elif color[len(color)-len("white"):len(color)]=="white":
    screen.blit(whiteHalfMarker, (x2,y2))
  elif color[len(color)-len("black"):len(color)]=="black":
    screen.blit(blackHalfMarker, (x2,y2))

  if cityLevel == 1:
    screen.blit(towerIm, (x,y))
  elif cityLevel == 2:
    screen.blit(keepIm, (x,y))
  elif cityLevel == 3:
    screen.blit(cityIm, (x,y))

#draw an army on a country
def drawArmy(country, color):
  global countryLocs, screen
  global redArmy, orangeArmy, yellowArmy, greenArmy
  global blueArmy, purpleArmy, whiteArmy, blackArmy
  x,y= countryLocs[country]
  x2, y2 = x+45, y-5
  
  if color[0:len("red")]=="red":
    screen.blit(redArmy, (x2, y2))
  elif color[0:len("orange")] == "orange":
    screen.blit(orangeArmy, (x2, y2))
  elif color[0:len("yellow")] == "yellow":
    screen.blit(yellowArmy, (x2, y2))
  elif color[0:len("green")] == "green":
    screen.blit(greenArmy, (x2, y2))
  elif color[0:len("blue")] == "blue":
    screen.blit(blueArmy, (x2, y2))
  elif color[0:len("purple")] == "purple":
    screen.blit(purpleArmy, (x2, y2))
  elif color[0:len("white")] == "white":
    screen.blit(whiteArmy, (x2, y2))
  elif color[0:len("black")]=="black":
    screen.blit(blackArmy, (x2, y2))
  elif color=="select":
    screen.blit(armySelection,(x2,y2))
    
  if color in heraldry:
    screen.blit(heraldry[color], (x2,y2))

#Test whether two coutries are adjacent
def adjacent(country1, country2):
  global adjacency
  count=  adjacency.count(country1+"-"+country2) + adjacency.count(country2+"-"+country1)
  return count>0

#create an army on a country
def createArmy(location, color):
  global armies, players
  players[color].command+=1
  armies.append(Army(location, color))

#disband army of location and color
def disbandArmy(army):
  global armies, players
  players[army.color].command-=1
  if army in armies:
      armies.remove(army)

#move an army from one country to another
def moveArmy(army, endLoc):
  global countryStats, armies
  if army in armies:
    countryStats[endLoc].occupier= army.color
    army.location= endLoc
  else:
    print "No "+color+" army to move at "+startLoc

#Retreat an army to an adjacent unoccupied country
def retreat(army, offLimits):
  global countryStats, armies, players
  players[army.color].command-=.2
  #Checks if valid retreat
  if not army in armies:
    print "No "+army.color+" army to retreat at "+army.location
    return
  #Finds unoccupied territories
  unoccupied=[]
  for country in countryStats:
    unoccupied.append(country)
  for a in armies:
    if a.location in unoccupied: unoccupied.remove(a.location)
  #Finds spaces available to move
  freeOwned=[]
  freeUnowned=[]
  for country in countryStats:
    if unoccupied.count(country)>0 and adjacent(country, army.location) and not offLimits==country:
      if countryStats[country].owner==army.color:
        freeOwned.append(country)
      else:
        freeUnowned.append(country)
  #Moves the army
  if len(freeOwned) > 0:
    moveArmy(army, freeOwned[0])
    print "Army at "+army.location+" retreated to "+freeOwned[0]
  elif len(freeUnowned) > 0:
    moveArmy(army, freeUnowned[0])
    print "Army at "+army.location+" retreated to "+freeUnowned[0]
  else: disbandArmy(army)

  
#Issue orders to an army
def orderArmy(army, arg2):
  global ordersQueue, countryStats, message
  if not army in armies:
    print "No "+army.color+" army to order at "+army.location
    return
  elif arg2 in countryStats:
    if adjacent(army.location, arg2) or army.location==arg2:
      ordersQueue[army]=arg2
      for a in ordersQueue:
        if ordersQueue[a]==army:
          ordersQueue[a]=a.location
    else:
      message= "Unable to order army from "+string.capwords(army.location)+" to "+string.capwords(arg2)
  else:
    if not ordersQueue[arg2] in countryStats:
      message= "Unable to support a support"
    elif adjacent(army.location,ordersQueue[arg2]) and ordersQueue[arg2] in countryStats:
      ordersQueue[army]=arg2
    else:
      message="Unable to lend support from "+string.capwords(army.location)+" to "+string.capwords(arg2.location)

#checks to see if all armies are holding
def __allHolding():
  global ordersQueue, countryStats
  allHolding=True
  for army in ordersQueue:
    target= ordersQueue[army]
    if target in countryStats and target!=army.location:
      allHolding= False 
  return allHolding

#Returns a list of contenders to a territory
def __getContenders(country):
  global ordersQueue
  contenders= []
  for army in ordersQueue:
    if country==ordersQueue[army]:
      contenders.append(army)
  return contenders

#resolves a conflict
def __resolve(contenders, country, support):
  maxSupport=0
  tie= False
  incumbent=Army("","")
  winner=Army("","")
  for army in contenders:
    location= army.location
    color= army.color
    if location==country: incumbent=army
    if support[army]>maxSupport:
      maxSupport= support[army]
      winner= army
      tie= False
    elif support[army]==maxSupport:
      tie= True
  return winner, incumbent, tie

#calculate support for each army
def __getSupport():
  global ordersQueue, players
  support={}
  for army in ordersQueue:
    support[army]=1
    for a in ordersQueue:
      if ordersQueue[a]==army:
        support[army]+=1
    #garners support from buildings
    target= ordersQueue[army]
    if target in countryStats:
      owner= countryStats[target].owner
      level= countryStats[target].level
      if owner==army.color and level==1:
        support[army]+=TOWERSUPPORT
      elif owner==army.color and level==2:
        support[army]+=KEEPSUPPORT
      elif owner==army.color and level==3:
        support[army]+=CITYSUPPORT
  return support

#Computes countries being invaded
def __getInvaded():
  global ordersQueue, countryStats
  invaded=[]
  for army in ordersQueue:
    target= ordersQueue[army]
    if target in countryStats and target!=army.location:
      invaded.append(target)
  return invaded

#Compute results of all ordered armies
def executeOrders():
  global ordersQueue, countryStats, players
  retreatQueue=[]
  #Loops until all commands have been resolved
  invaded= __getInvaded()
  while(not __allHolding()):
    #if support is cut, issue a hold instead
    for army in ordersQueue:
      target= ordersQueue[army]
      if (not target in countryStats) and (army.location in invaded):
        ordersQueue[army]= army.location
    support= __getSupport()
    #if invasion with incumbent, resolve, issue holds instead
    invaded=__getInvaded()
    #loop over all countries being invaded
    for country in invaded:
      contenders= __getContenders(country)
      winner, incumbent, tie= __resolve(contenders, country, support)
      #if meets criteria
      if len(contenders)>1 and not incumbent.color=="":
        if tie:
          for army in contenders:
            ordersQueue[army]= army.location
        elif winner==incumbent or winner.color==incumbent.color:
          for army in contenders:
            ordersQueue[army]= army.location
        else:
          #supplant incumbent
          del ordersQueue[incumbent]
          contenders.remove(incumbent)
          retreatQueue.append((incumbent,winner.location))
          #move in winner
          players[winner.color].command+=.2
          players[winner.color].subtlety-=.1
          del ordersQueue[winner]
          contenders.remove(winner)
          moveArmy(winner, country)
          ordersQueue[winner]=country
          #reset rest
          for army in contenders:
            ordersQueue[army]= army.location
      support= __getSupport()
    #if invasion without an incumbent, resolve, issue holds instead
    invaded=__getInvaded()
    #loop over all countries being invaded
    for country in invaded:
      contenders= __getContenders(country)
      winner, incumbent, tie= __resolve(contenders, country, support)
      #if meets criteria
      if len(contenders)>1 and incumbent.color=="":
        if tie:
          for army in contenders:
            ordersQueue[army]= army.location
        else:
          #move in winner
          players[winner.color].command+=.2
          players[winner.color].subtlety-=.1
          del ordersQueue[winner]
          contenders.remove(winner)
          moveArmy(winner, country)
          ordersQueue[winner]=country
          #reset rest
          for army in contenders:
            ordersQueue[army]= army.location
      support= __getSupport()
    #if a move is unopposed, resolve and issue hold instead
    invaded=__getInvaded()
    #loop over all countries being invaded
    for country in invaded:
      contenders= __getContenders(country)
      winner, incumbent, tie= __resolve(contenders, country, support)
      #if meets criteria
      if len(contenders)==1 and incumbent.color=="":
        #move in winner
        del ordersQueue[winner]
        contenders.remove(winner)
        moveArmy(winner, country)
        ordersQueue[winner]=country
      support= __getSupport()
  #retreat any armies that need retreating
  for (army,limits) in retreatQueue:
    retreat(army,limits)

#compute all siege mechanisms
def computeSiege():
  global countryStats, armies, building, players
  #compute occupations
  for country in countryStats:
    countryStats[country].occupier= countryStats[country].owner
  for army in armies:
    countryStats[army.location].occupier= army.color
  #compute siege delays
  for country in countryStats:
    siege= countryStats[country].siege
    level= countryStats[country].level
    occupier= countryStats[country].occupier
    owner= countryStats[country].owner
    if siege < 0 and owner!=occupier:
      siege= SIEGEFACTOR*level
      price=0
      if level==1: price=TOWERCOST
      elif level==2: price=KEEPCOST
      elif level==3: price=CITYCOST
      if occupier in callBanners(PLAYERCOLOR) and not owner in callBanners(PLAYERCOLOR) and level>0:
        if coffers[occupier]>=price:
          decision= Decision("Do you wish to raze the buildings on "+string.capwords(country)+"?","","raze", country, "")
          decisionQueue.append(decision)
    if owner!=occupier:
      siege= siege-1
      #Have loser swear fealty
      if siege>0 and owner!=PLAYERCOLOR: players[owner].AI.underSiege(country, occupier, siege)
      if siege <= 0:
        if owner!="none": players[owner].command-=.2
        if owner!="none" and country in players[owner].titles: players[owner].titles.remove(country)
        #change region ownership
        loser= owner
        owner= occupier
        if country in building:
          del building[country]
        if loser!=PLAYERCOLOR and loser!="none": players[loser].AI.regionTaken(country, occupier)
        #If loser was vassal of winner, free them
        if level > 1 and loser in callBanners(owner):
          players[occupier].honor-=1
        if level > 0:
          print country+" has fallen to siege."
          players[occupier].command+=.5
          players[occupier].dread+=.2
        else:
          print country+" has been taken."
          players[occupier].command+=.2
          players[occupier].greed+=.1
        #if house obliterated, set dread high
        if loser!="none" and countArmies(loser)<1 and len(ownedCountries(loser))<2:
          players[occupier].dread+=4
    else:
      siege= -1
    countryStats[country].level= level
    countryStats[country].owner= owner
    countryStats[country].occupier= occupier
    countryStats[country].siege= siege

#build on a territory
def build(country):
  global countryStats, building, coffers, message
  if not country in building:
    level= countryStats[country].level
    owner= countryStats[country].owner
    if (level < 3) and (owner in coffers):
      price=0
      if level==0: price= TOWERCOST
      elif level==1: price= KEEPCOST
      else: price=CITYCOST
      if coffers[owner]>=price:
        coffers[owner]= coffers[owner]-price
        building[country]= BUILDFACTOR*(level+1)
        print "Starting building on "+string.capwords(country)+"..."
      else:
        message= "Not enough gold to build on "+string.capwords(country)
    else:
      message= "Unable to build on "+string.capwords(country)

#cancel a building, once commanded
def cancelBuild(country):
  global countryStats, building, coffers, message
  if country in building:
    level= countryStats[country].level
    owner= countryStats[country].owner
    if level==0: price= TOWERCOST
    elif level==1: price= KEEPCOST
    else: price=CITYCOST
    coffers[owner]= coffers[owner] + price
    del building[country]
    message= "Building canceled on "+string.capwords(country)
  else:
    print "No building to cancel on "+string.capwords(country)

#compute all buildings in queue
def computeBuilding():
  global building, countryStats
  remove= []
  for country in building:
    building[country]= building[country]-1
    if building[country]<=0:
      countryStats[country].level+=1
      remove.append(country)
      print "building completed on "+country
  for key in remove:
    del building[key]

#compute income from land holdings
def computeIncome():
  global coffers, countryStats
  for country in countryStats:
    owner= countryStats[country].owner
    if owner!="none":
      if not (owner in coffers):
        coffers[owner]= STARTING_GOLD
      coffers[owner]= coffers[owner]+countryStats[country].income
    countryStats[country].income*=INFLATION
  
#See if there is an army of color on location
def armyOn(location, color):
  for army in armies:
    if army.location==location and army.color==color:
      return True
  return False
  
#add new armies gained from resource control
def levyTroops():
  global armies, countryStats
  players= {}
  available= {}
  for country in countryStats:
    owner= countryStats[country].owner
    occupier= countryStats[country].occupier
    level= countryStats[country].level
    if not (owner in players):
      players[owner]= 0
      available[owner]= []
    if not (occupier in players):
      players[occupier]= 0
      available[occupier]= []
    if level>=2:
      players[owner]+=1
    if armyOn(country,occupier):
      players[occupier]= players[occupier]-1
      
    if (owner == occupier) and not armyOn(country,owner) and level>=2: 
      available[owner].append(country)
  for color in players:
    if players[color] > 0:
      for i in range(0,players[color]):
        try:
          loc= available[color].pop()
          createArmy(loc,color)
          print color+" army raised at "+loc
        except IndexError:
          print "unable to place "+color+" army"
    elif players[color] < 0:
      remove= []
      for i in range(0,-players[color]):
        removed=False
        for army in armies:
          if army.color == color and not removed and not army in remove: 
            remove.append(army)
            removed=True
      for army in remove:
        disbandArmy(army)
        print owner+" army disbanded at "+army.location

#Deals with a user click on an army
def processArmy(closestArmy, closestArmyLoc, selected, supporting):
  global message
  if selected=="none":
    selected= closestArmy
    message= "Army in "+string.capwords(closestArmyLoc)+"..."
  elif selected.location==closestArmyLoc:
    message="...hold"
    orderArmy(selected, closestArmyLoc)
    selected= "none"
    supporting=False
  elif supporting:
    supporting= False
    message="...army at "+string.capwords(closestArmyLoc)
    orderArmy(selected, closestArmy)
    selected="none"
  else:
    message="...move to "+string.capwords(closestArmyLoc)
    orderArmy(selected, closestArmyLoc)
    selected="none"
  return selected,supporting

#Frees a color from all pledged calls
def freeBanner(color):
  global bannersDict, players
  #Updates stats
  players[color].command+=2
  players[color].honor-=1
  players[color].title="King"
  players[color].titles=[]
  for colorOver in bannersDict:
    if colorOver!=color and color in bannersDict[colorOver]:
      bannersDict[colorOver].remove(color)

#Frees underColor from all pledged calls, then pledges to overColor
def swearBanner(colorOver, colorUnder):
  global bannersDict, players
  players[colorUnder].command-=1
  players[colorUnder].honor+=2
  players[colorOver].command+=2
  players[colorOver].subtlety+=1
  freeBanner(colorUnder)
  players[colorUnder].title="Lord"
  string= "House "+players[colorUnder].house+" has sworn allegiance to House "+players[colorOver].house
  print string
  infoMessages.append(Message(string, "alliance"))
  if not colorOver in bannersDict:
    bannersDict[colorOver]= [colorOver, colorUnder]
  else:
    bannersDict[colorOver].append(colorUnder)
  if not colorUnder in bannersDict:
    bannersDict[colorUnder]= [colorUnder]

#Returns a list of all colors pledged to the specified color
def callBanners(color):
  global bannersDict
  if not color in bannersDict:
    return [color]
  stack= []
  stack.extend(bannersDict[color])
  banners= []
  while stack!=[]:
    next= stack.pop()
    if not next in banners:
      banners.append(next)
      stack.extend(bannersDict[next])
  return banners

#Returns the liege lord of this player
def getLiege(color):
  global bannersDict
  for col in bannersDict:
    if col!= color and color in bannersDict[col]:
      return col
  return color

#Returns a list of the countries owned by a player
def ownedCountries(color):
  global countryStats
  result=[]
  for country in countryStats:
    owner= countryStats[country].owner
    if owner==color: result.append(country)
  return result

#Returns a list of the countries owned by a player
def countArmies(color):
  global armies
  result=0
  for army in armies:
    if army.color==color: result+=1
  return result

#Computes the player events
def computeAlliances(init):
  global players, bannersDict
  #remove dead players
  remove=[]
  for color in players:
    if len(ownedCountries(color))<1 and countArmies(color)<1:
      vassals=[]
      if color in bannersDict: vassals.extend(bannersDict[color])
      for col in vassals:
        freeBanner(col)
      remove.append(color)
  for col in remove:
    if not init:
      infoMessages.append(Message("House "+players[col].house+" has been obliterated", "obliteration"))
    del players[col]
  #Loop over remaining players
  for color in players:
    #Compute random rebellions
    if color!=PLAYERCOLOR and getLiege(color)!=color:
      player= players[color]
      liege= players[getLiege(color)]
      prob=PROB_REBEL
      prob+= (PROB_REBEL/20.0)*float(player.greed) + (PROB_REBEL/10.0)*float(player.command) - (PROB_REBEL/5.0)*float(player.honor)
      prob-= (PROB_REBEL/10.0)*float(liege.command) + (PROB_REBEL/5.0)*float(liege.dread) + (PROB_REBEL/20.0)*float(liege.honor)
      prob-= (PROB_REBEL/5.0)*float(len(player.titles))
      if random.random() < prob:
        freeBanner(color)
        string= "House "+player.house+" has rebelled."
        print string
        infoMessages.append(Message(string, "rebellion"))
    #compute random alliances
    if random.random()<PROB_RAND_ALLIANCE and color!=PLAYERCOLOR and getLiege(color)==color:
      vassals= callBanners(color)
      liege=""
      maxHonor= -250
      for col in players:
        if players[col].honor > maxHonor and not col in vassals:
          liege= col
          maxHonor= players[col].honor
      if liege!="":
        if liege==PLAYERCOLOR:
          decision= Decision("House "+players[color].house+" wishes to swear allegiance to you.", "Do you accept?", "fealty", liege, color)
          decisionQueue.append(decision)
        else:
          swearBanner(liege, color)
    #compute heirs and daughters
    if random.random()<PROB_SON:
      players[color].heir()
      player= players[color]
      string= "House "+player.house+" celebrates the birth of "+player.heirs[len(player.heirs)-1]
      print string
    if random.random()<PROB_DAUGHTER:
      players[color].daughters+=1
      string="House "+players[color].house+" celebrates the coming of age of a new princess"
      if color==PLAYERCOLOR:
        infoMessages.append(Message("A daughter of your House has reached marriageable age.", "daughter"))
    #compute deaths
    if random.random()<PROB_DEATH:
      player= players[color]
      print player.getLord()+" has died.",
      player.reRoll()
      string= "House "+player.house+" is now ruled by "+player.getLord()+", whom men call the "+player.monkier
      print string
      infoMessages.append(Message(string, "succession"))

#Process the clicked country
def processCountry(country):
  global countryStats, players, allianceAsked, message
  owner= countryStats[country].owner
  if owner in callBanners(PLAYERCOLOR):
    if country in building:
      cancelBuild(country)
    else: build(country)
  
def considerAlliance(color1, color2, daughter):
  global players
  if color1=="none" or color2=="none": return
  prob=.05
  difference= len(ownedCountries(color1))-len(ownedCountries(color2))
  prob+= 0.1 * float(difference)
  prob+= 0.02 * float(players[color1].dread)
  prob+= 0.05 * float(players[color1].subtlety)
  prob-= 0.05 * float(players[color2].command)
  if daughter: prob+=.33
  if random.random() < prob:
    if daughter: players[color1].daughters-=1
    swearBanner(color1, color2)

def grantTitle(color, country):
  global players, message
  if country in players[color].titles:
    message= "Title has already been granted"
    return
  players[color].titles.append(country)

#Process a decision from the decision queue
def processDecision(decision, selection):
  global players, allianceAsked, coffers, countryStats, message
  #Process an offer of fealty
  if decision.Dtype=="fealty":
    if selection:
      swearBanner(decision.color1, decision.color2)
      players[decision.color1].honor+=1
      players[decision.color1].dread-=1
    else:
      players[decision.color1].honor-=1
      players[decision.color1].dread+=1
  #Process an offer of alliance
  elif decision.Dtype=="alliance":
    if selection:
      if players[decision.color1].daughters>0:
        prompt="Do you wish to offer her hand as part of the alliance to House "+players[decision.color2].house+"?"
        decision= Decision("Your house has a daughter of marriageable age.",prompt,"daughter", decision.color1, decision.color2)
        decisionQueue.append(decision)
      else:
        considerAlliance(decision.color1, decision.color2, False)
    else: allianceAsked.remove(decision.color2)
  #Process a marriage proposal
  elif decision.Dtype=="daughter":
    considerAlliance(decision.color1, decision.color2, True)
  #Process a decision to raze buildings
  elif decision.Dtype=="raze" and selection:
    if decision.color2 in callBanners(PLAYERCOLOR) and decision.color2!=PLAYERCOLOR:
      players[PLAYERCOLOR].honor-=1
    raze(decision.color1)
  #Process decision to assassinate lord
  elif decision.Dtype=="assassinLord" and selection:
    sendAssassin(decision.color1, decision.color2, KING)
  #Process a decision to assassinate daughter
  elif decision.Dtype=="assassinDaughter" and selection:
    sendAssassin(decision.color1, decision.color2, DAUGHTER)
  #Process a decision to bribe a castellan
  elif decision.Dtype=="bribe" and selection:
    if not (decision.color1, decision.color2) in bribeQueue:
      bribeQueue.append((decision.color1, decision.color2))
      coffers[decision.color1]-=bribePrice(decision.color2)
  #Process decision to salt and burn a region
  elif decision.Dtype=="burn" and selection:
    if countryStats[decision.color1].income > (float(INCOME) * BURNFACTOR * INFLATION**BURN_DELAY):
      countryStats[decision.color1].income=float(INCOME)*BURNFACTOR
      occupier= countryStats[decision.color1].occupier
      owner= countryStats[decision.color1].owner
      players[occupier].dread+=2
      if owner!=PLAYERCOLOR: players[owner].AI.regionBurned(decision.color1, occupier)
    else:
      message= "Region has already been burned"
  #Process a decision to grant a title
  elif decision.Dtype=="title" and selection:
    grantTitle(decision.color1, decision.color2)

#razes the buildings on a territory
def raze(country):
  global countryStats, coffers, message, players
  cancelBuild(country)
  price=0
  level= countryStats[country].level
  if level==0:
    message= "Nothing to raze"
    return
  occupier= countryStats[country].occupier
  if level==1: price= TOWERCOST
  elif level==2: price= KEEPCOST
  elif level==3: price= CITYCOST
  if coffers[occupier]>=price:
    countryStats[country].level= 0
    countryStats[country].siege=0
    coffers[occupier]-=price
    print "Building razed on "+string.capwords(country)
    players[occupier].dread+=1
    players[occupier].honor-=0.5
    owner=countryStats[country].owner
    if owner!=PLAYERCOLOR: players[owner].AI.regionRazed(country,occupier)
  else:
    message="Not enough gold to raze building"
    
#Sends an assassin to try to kill a king or a daughter
def sendAssassin(fromColor, color, target):
  global players, coffers, failedAssassins
  price=ASSASSIN_COST
  prob =PROB_ASSASSIN
  prob-= (PROB_ASSASSIN/5.0)*players[color].subtlety
  prob-= (PROB_ASSASSIN/10.0)*players[color].command
  prob+= (PROB_ASSASSIN/5.0)*players[color].dread
  if target==DAUGHTER: 
    prob+=PROB_ASSASSIN*3.0
  if fromColor in coffers and coffers[fromColor]>=price:
    coffers[fromColor]-=price
  else: return
  if random.random() < prob and not (color,target) in assassinsQueue:
    assassinsQueue.append((color,target))
    players[fromColor].subtlety+=2
    players[fromColor].honor-=2
  elif color==PLAYERCOLOR: failedAssassins+=1

#Computes the results of all sucessful assassinations
def computeAssassinations():
  global players, assassinsQueue, failedAssassins, infoMessages
  for (color,target) in assassinsQueue:
    string=""
    if target==KING:
      string=players[color].getLord()+" has been assassinated"
      players[color].reRoll()
    elif target==DAUGHTER and players[color].daughters>0:
      string="A daughter of House "+players[color].house+" has been assassinated"
      players[color].daughters-=1
    if string!="":
      infoMessages.append(Message(string, "assassination"))
      print string
  if failedAssassins==1:
    stringM= "You have captured an enemy assassin, sent to your court."
    infoMessages.append(Message(stringM, "failed assassin"))
  elif failedAssassins>1:
    stringM= "You have captured "+str(failedAssassins)+" enemy assassins, sent to your court."
    infoMessages.append(Message(stringM, "failed assassin"))
  assassinsQueue= []
  failedAssassins= 0
  
#Compute a bribe price
def bribePrice(country):
  global players, countryStats
  price=CITYCOST
  if countryStats[country].level==1: price= TOWERCOST
  elif countryStats[country].level==2: price= KEEPCOST
  player= players[countryStats[country].owner]
  price= price*3
  price+= (float(price)/3)*player.honor
  price-= (float(price)/5)*player.greed
  return max(price, TOWERCOST)
  
#Compute all bribes and switch alliances
def computeBribes():
  global players, countryStats, infoMessages, bribeQueue
  for (color, country) in bribeQueue:
    if countryStats[country].level > 0:
      if len(ownedCountries(countryStats[country].owner))<2:
        if color==PLAYERCOLOR:
          infoMessages.append(Message("Attempt to bribe castellan of "+string.capwords(country)+" failed.", "bribe failure"))
      elif random.random() < PROB_BRIBE_FAIL and color==PLAYERCOLOR:
        infoMessages.append(Message("Attempt to bribe castellan of "+string.capwords(country)+" failed.", "bribe failure"))
      else: 
        loser= players[countryStats[country].owner]
        if country in loser.titles: loser.titles.remove(country)
        countryStats[country].owner= color
        players[color].subtlety+=1
        infoMessages.append(Message("Garrison at "+string.capwords(country)+" has been bribed by House "+players[color].house, "bribe"))
        if loser.color!=PLAYERCOLOR: loser.AI.regionBribed(country, color)
  bribeQueue= []
  
#Bribe the castellan of a country
def bribeCastellan(country, color):
  global coffers, message, countryStats, bribeQueue, decisionQueue
  if countryStats[country].level==0: 
    if color==PLAYERCOLOR: message= "No castellan to bribe"
    else: return
  price=bribePrice(country)
  if not color in coffers or coffers[color]<price: 
    if color==PLAYERCOLOR: message= "Unable to afford bribe"
    else:return
  else:
    if color==PLAYERCOLOR:
      prompt= "Do you wish to bribe the castellan of "+string.capwords(country)+"?"
      decision= Decision("Bribe will cost "+str(int(price)), prompt, "bribe", PLAYERCOLOR, country)
      decisionQueue.append(decision)
    else:
      coffers[color]-=price
      if not (color, country) in bribeQueue: bribeQueue.append((color, country))
  
#Process a command to assassinate someone
def processAssassin(color, target):
  global coffers, players, message
  if coffers[PLAYERCOLOR]<ASSASSIN_COST:
    message= "Unable to afford assassin"
  elif target==KING:
    prompt="This assassin will attempt to kill "+players[color].getLord()+" of House "+players[color].house
    decision= Decision(prompt,"Do you wish to send assassin?","assassinLord", PLAYERCOLOR, color)
    decisionQueue.append(decision)
  elif target==DAUGHTER:
    prompt="This assassin will attempt to kill a princess of House "+players[color].house
    decision= Decision(prompt,"Do you wish to send assassin?","assassinDaughter", PLAYERCOLOR, color)
    decisionQueue.append(decision)

#Returns the ultimate overlord of the specified color
def getOverlord(color):
  if getLiege(color)==color: return color
  col= color
  while col!=getLiege(col):
    col= getLiege(col)
  return col
